/* 
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   -
   - The Original Code is this file as it was released on
   - 11 December, 2003.
   -
   - The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
   - Portions created by Henk-Johan van Rantwijk are Copyright (C) 2000
   - Henk-Johan van Rantwijk.  All Rights Reserved.
   -
   - Contributor(s):
   -   Henk-Johan van Rantwijk <bugs4hj@netscape.net> (Original Author)
   -
   - Alternatively, the contents of this file may be used under the
   - terms of the GNU General Public License Version 2 or later (the
   - "GPL"), in which case the provisions of the GPL are applicable
   - instead of those above.  If you wish to allow use of your
   - version of this file only under the terms of the GPL and not to
   - allow others to use your version of this file under the MPL,
   - indicate your decision by deleting the provisions above and
   - replace them with the notice and other provisions required by
   - the GPL.  If you do not delete the provisions above, a recipient
   - may use your version of this file under either the MPL or the
   - GPL.
   -
   - this can be used by adding:
     <vbox id="appcontent" onclick="multiZillaAntiCMenuHijack.click(event);"/>
     to [your overlay name].xul
*/

////////////////////////////////////////////////////////////////////////////////
// JavaScript 'class' to preserve YOUR context menu :-)
////////////////////////////////////////////////////////////////////////////////
var multiZillaAntiCMenuHijack = 
{
  aBundle : null,

  init : function ()
  {
    aBundle = srGetStrBundle("chrome://multiviews/locale/tabbrowser.properties");
  },

  click : function (event)
  {
    if (event.button == 2 ) {
      var cmCheckPrefValue = 0;

      try {
        cmCheckPrefValue = pref.getIntPref("multizilla.document.context-menu.behavior");
      }
      catch(ex) {
        pref.setIntPref("multizilla.document.context-menu.behavior", cmCheckPrefValue);
      }

      if (cmCheckPrefValue > 0 )
        this.contextMenuCheck(event.originalTarget.ownerDocument, cmCheckPrefValue);
    }
  },

  contextMenuCheck : function (aDocument, aAction)
  {
    if (aDocument != null) {
      var hasModifiedContextMenu = (aAction == 2) ? true : false;

      if (aAction == 1) {
        if (this.checkContextMenu(aDocument))
          hasModifiedContextMenu = true;
        if (_content.frames.length) {
          for (var i = 0; i < _content.frames.length; i++) {
            if (this.checkContextMenu(_content.frames[i].document)) {
              hasModifiedContextMenu = true;
              break;
            }
          }
        }
      }
      if (hasModifiedContextMenu) {
        if (aAction == 1 && !this.confirmReset())
          return;
        this.resetOnContextMenu(aDocument);

        if (_content.frames.length) {
          for (i = 0; i < _content.frames.length; i++) 
            this.resetOnContextMenu(_content.frames[i].document);
        }
      }
    }
  },

  checkContextMenu : function (aDocument)
  {
    var returnTrue = "return true;";
    var contextMenuState = false;
    var element = aDocument.getElementsByTagName('html')[0];

    if (element && 'oncontextmenu' in element) {
      if (element.oncontextmenu != undefined)
        contextMenuState = true;
    }

    if ('oncontextmenu' in aDocument && aDocument.oncontextmenu != undefined || 
        'onmouseup' in aDocument && aDocument.onmouseup != undefined || 
        'onmousedown' in aDocument && aDocument.onmousedown != undefined)
      contextMenuState = true;

    element = aDocument.getElementsByTagName('body')[0];

    if (element && element.hasAttribute('oncontextmenu')) {
      if (element.getAttribute('oncontextmenu') != returnTrue)
        contextMenuState = true;
    }
    return (contextMenuState);
  },

  confirmReset : function ()
  {
    var checkbox = {value:false};

    /* var dialogTitle = "mzWizard=MultiZilla Wizard";
    var dialogText = "Warning: this site changed or disabled your context menu.\n\nWould you like to reinitiate the original context menu?";
    var checkboxText = "Always preserve my context menu"; */

    var dialogTitle = aBundle.GetStringFromName('mzWizard');
    var dialogText = aBundle.GetStringFromName('contextMenuCheckTitle');
    var checkboxText = aBundle.GetStringFromName('contextMenuCheckCheckbox');

    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                                  .getService(Components.interfaces.nsIPromptService);

    var result = promptService.confirmEx(window, dialogTitle, dialogText, 
                                        (promptService.BUTTON_POS_0 * promptService.BUTTON_TITLE_YES) +
                                        (promptService.BUTTON_POS_1 * promptService.BUTTON_TITLE_NO),
                                         null, null, null, checkboxText, checkbox);
    if (result)
      return false;
    else if (checkbox.value)
      pref.setIntPref("multizilla.document.context-menu.behavior", 2);
    return true;
  },

  resetOnContextMenu : function (aDocument)
  {
    var returnTrue = "return true;"
    var element = aDocument.getElementsByTagName('html')[0];

    element.onmouseup = undefined;
    element.onmousedown = undefined;
    element.oncontextmenu = undefined;

    aDocument.onmouseup = undefined;
    aDocument.onmousedown = undefined;
    aDocument.oncontextmenu = undefined;

    element = aDocument.getElementsByTagName('body')[0];

    if (element && element.getAttribute('oncontextmenu') != returnTrue)
      element.setAttribute('oncontextmenu', returnTrue);
  }
};

addEventListener("load", multiZillaAntiCMenuHijack.init, false);